﻿// Pendent:
// Mirar si navegador soporta Localstorage
// Afegir icones al peu segons quina pàgina
// Estètica general (logo inicial, fons de pantalla, mida texte, colors, icones

var tempsRefresc = 5 * 60 * 1000;
var Geo = {};
var demanarDades = false;
var map;
var lastMarker;

function obtenirDades() {
    obtenirDadesEstacions();
    setTimeout(function () {
        obtenirDades();
    }, tempsRefresc);
}

function obtenirDadesEstacions() {
    if (!refrescant) {
        refrescant = true;
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(okPosition, errorPosition);
        }
        else {
            errorGeo();
            if (demanarDades) {
                demanarDades = false;
                $("#popupNoGeo").popup("open");
                setTimeout(function () {
                    $("#popupNoGeo").popup("close");
                }, 3000);
            }
        }
    }
}

function okPosition(position) {
    Geo.lat = position.coords.latitude;
    Geo.lng = position.coords.longitude;
    obtenirEstacions(Geo.lat, Geo.lng);
}

function errorPosition() {
    errorGeo();
    if (demanarDades) {
        demanarDades = false;
        $("#popupErrorGeo").popup("open");
        setTimeout(function () {
            $("#popupErrorGeo").popup("close");
        }, 3000);
    }
}
function obtenirEstacions(lat, lng) {
    if (lat == "x") {
        refrescant = false;
        loading("hide");
    }
    else {
        $.ajax({
            type: "POST",
            url: "../bicisXTots.asmx/ObtenirDadesEstacions",
            data: "{ lat: " + lat + ", lng: " + lng + " }",
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function (data) {
                var myData = data.d;
                if ("dadesEstacions" in localStorage) {
                    localStorage.removeItem("dadesEstacions");
                }
                localStorage.dadesEstacions = JSON.stringify(myData);
                refrescant = false;
                demanarDades = false;
                loading("hide");
            },
            error: function (msg) {
                refrescant = false;
                loading("hide");
            }
        });


    }

}

function mostrarEstacions() {
    var output = [];
    if (localStorage.dadesEstacions != null) {
        var estacions = obtenirEstacionsLocal();
        $.each(estacions, function (i, item) {
            var adreca;
            var iden;
            var bicis = item.BicisLliures;
            var aparcaments = item.AparcamentsLliures;
            var colorB = "red";
            var colorA = "red";
            var texteB = "bicis";
            var texteA = "slots";
            var imgB = "<img src='images/Bicycle_Plain_Red.png' style='vertical-align:middle'>";
            var imgA = "<img src='images/Parking_P_Plain_Red.png' style='vertical-align:middle'>";
            var imgPreferida = "";

            adreca = item.Carrer;
            if (item.NumeroCarrer != null && item.NumeroCarrer != "") {
                adreca += ", " + item.NumeroCarrer;
            }
            iden = item.Identificador + " - " + adreca;

            if (bicis >= 5) {
                colorB = "green";
                imgB = "<img src='images/Bicycle_Plain_Green.png' style='vertical-align:middle'>";
            }
            else if (bicis > 0) {
                colorB = "orange";
                imgB = "<img src='images/Bicycle_Plain_Orange.png' style='vertical-align:middle'>";
            }
            if (aparcaments >= 5) {
                colorA = "green";
                imgA = "<img src='images/Parking_P_Plain_Green.png' style='vertical-align:middle'>";
            }
            else if (aparcaments > 0) {
                colorA = "orange";
                imgA = "<img src='images/Parking_P_Plain_Orange.png' style='vertical-align:middle'>";
            }
            if (bicis == 1) texteB = "bici";
            if (aparcaments == 1) texteA = "slot";
            if (esPreferida(item.Identificador)) imgPreferida = "<img src='images/star.png' alt='Estació Preferida' class='ui-li-icon' style='vertical-align:middle'>";
            output.push('<li><a href="?id=' + item.Identificador + '#estacio" rel="external">'
                            + imgPreferida
                            + iden
                            + '<br/><br/><p>'
                            + Math.round(item.Distancia)
                            + ' metres</p>'
                            + '<p class="ui-li-aside">'
                            + '<font color="' + colorB + '">' + bicis + ' ' + imgB + '</font>'
                            + '<br/><br/>'
                            + '<font color="' + colorA + '">' + aparcaments + ' ' + imgA + '</font>'
                            + '</p>'
                            + '</a></li>');
        });
        $('#llistaEstacions').children("ul").empty().append(output.join("")).listview("refresh");
    }
}

function mostrarEstacionsPreferides() {
    if (localStorage["estacionsPreferides"] != undefined
        && JSON.parse(localStorage["estacionsPreferides"]).length > 0) {
        var output = [];
        var estacions = obtenirEstacionsLocal();
        var preferides = JSON.parse(localStorage["estacionsPreferides"]);
        estacions = $.grep(estacions, function (valor, j) {
            return $.inArray(valor.Identificador, preferides) >= 0;
        });
        var estacionsPreferides = JSON.parse(localStorage.estacionsPreferides);
        $.each(estacions, function (i, item) {
            var adreca;
            var iden;
            var bicis = item.BicisLliures;
            var aparcaments = item.AparcamentsLliures;
            var colorB = "red";
            var colorA = "red";
            var texteB = "bicis";
            var texteA = "slots";
            var imgB = "<img src='images/Bicycle_Plain_Red.png' style='vertical-align:middle'>";
            var imgA = "<img src='images/Parking_P_Plain_Red.png' style='vertical-align:middle'>";

            adreca = item.Carrer;
            if (item.NumeroCarrer != null && item.NumeroCarrer != "") {
                adreca += ", " + item.NumeroCarrer;
            }
            iden = item.Identificador + " - " + adreca;

            if (bicis >= 5) {
                colorB = "green";
                imgB = "<img src='images/Bicycle_Plain_Green.png' style='vertical-align:middle'>";
            }
            else if (bicis > 0) {
                colorB = "orange";
                imgB = "<img src='images/Bicycle_Plain_Orange.png' style='vertical-align:middle'>";
            }
            if (aparcaments >= 5) {
                colorA = "green";
                imgA = "<img src='images/Parking_P_Plain_Green.png' style='vertical-align:middle'>";
            }
            else if (aparcaments > 0) {
                colorA = "orange";
                imgA = "<img src='images/Parking_P_Plain_Orange.png' style='vertical-align:middle'>";
            }
            if (bicis == 1) texteB = "bici";
            if (aparcaments == 1) texteA = "slot";
            output.push('<li><a href="?id=' + item.Identificador + '#estacio" rel="external">'
                            + '<img src="images/star.png" alt="Estació Preferida" class="ui-li-icon">'
                            + iden
                            + '<br/><br/><p>'
                            + Math.round(item.Distancia)
                            + ' metres</p>'
                            + '<p class="ui-li-aside">'
                            + '<font color="' + colorB + '">' + bicis + ' ' + imgB + '</font>'
                            + '<br/><br/>'
                            + '<font color="' + colorA + '">' + aparcaments + ' ' + imgA + '</font>'
                            + '</p>'
                            + '</a></li>');
        });
        $('#llistaEstacionsPreferides').children("ul").empty().append(output.join("")).listview("refresh");
    } else {
        $("#popupNoPreferides").popup("open");
        setTimeout(function () {
            $("#popupNoPreferides").popup("close");
        }, 3000);
    }
}

function mostrarEstacionsMapa(identificador) {
    var latlon;

    var myOptions;


    if (localStorage.dadesEstacions != null) {
        var marker;
        var markerPosition;
        var infoMarker;
        var output = [];
        var bicis;
        var aparcaments;
        var icon;
        var estacions = obtenirEstacionsLocal();
        var estacio;
        var adreca;
        var iden;

        if (identificador != null) {
            // Obtenim estacio amb identificador i emplenem dades pàgina 'Estació'
            estacio = obtenirEstacioLocal(identificador)[0];
        } else {
            estacio = estacions[0];
        }

        latlon = new google.maps.LatLng(estacio.Latitud, estacio.Longitud);

        myOptions = {
            zoom: 15,
            center: latlon,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        }

        map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);

        $.each(estacions, function (i, item) {
            crearMarca(i, item, identificador);
        });
    }
}

function crearMarca(i, item, identificador) {
    bicis = item.BicisLliures;
    aparcaments = item.AparcamentsLliures;
    icon = "http://labs.google.com/ridefinder/images/mm_20_red.png";
    if (bicis >= 5) icon = "http://labs.google.com/ridefinder/images/mm_20_green.png";
    else if (bicis > 0) icon = "http://labs.google.com/ridefinder/images/mm_20_orange.png";
    else if (item.Estat == "CLS") icon = "http://labs.google.com/ridefinder/images/mm_20_black.png";
    markerPosition = new google.maps.LatLng(item.Latitud, item.Longitud);

    marker = new google.maps.Marker({
        position: markerPosition,
        map: map,
        icon: icon
    })

    adreca = item.Carrer;
    if (item.NumeroCarrer != null && item.NumeroCarrer != "") {
        adreca += ", " + item.NumeroCarrer;
    }
    iden = item.Identificador + " - " + adreca;

    marker.infowindow = new google.maps.InfoWindow({
        content: iden
    });

    if ((identificador != null && identificador == item.Identificador) ||
        (identificador == null && i == 0)) {
        lastMarker = marker.infowindow;
        marker.infowindow.open(map, marker);
        actualitzarInfoEstacio(item, iden);
    } else {
        marker.infowindow.close();
    }

    (function (estacio, m, i) {
        google.maps.event.addListener(marker, 'click', function () {
            lastMarker.close();
            latlon = new google.maps.LatLng(estacio.Latitud, estacio.Longitud);
            //map.setCenter(latlon);
            map.panTo(latlon);
            m.infowindow.open(map, m);
            lastMarker = m.infowindow;
            actualitzarInfoEstacio(estacio, i);
        });
    })(item, marker, iden);

}

function actualitzarInfoEstacio(item, iden) {
    output = [];
    var bicis = item.BicisLliures;
    var aparcaments = item.AparcamentsLliures;
    var colorB = "red";
    var colorA = "red";
    var texteB = "bicis";
    var texteA = "buits";
    var imgB = "<img src='images/Bicycle_Plain_Red.png' style='vertical-align:middle'>";
    var imgA = "<img src='images/Parking_P_Plain_Red.png' style='vertical-align:middle'>";
    if (bicis >= 5) {
        colorB = "green";
        imgB = "<img src='images/Bicycle_Plain_Green.png' style='vertical-align:middle'>";
    }
    else if (bicis > 0) {
        colorB = "orange";
        imgB = "<img src='images/Bicycle_Plain_Orange.png' style='vertical-align:middle'>";
    }
    if (aparcaments >= 5) {
        colorA = "green";
        imgA = "<img src='images/Parking_P_Plain_Green.png' style='vertical-align:middle'>";
    }
    else if (aparcaments > 0) {
        colorA = "orange";
        imgA = "<img src='images/Parking_P_Plain_Orange.png' style='vertical-align:middle'>";
    }
    if (bicis == 1) texteB = "bici";
    if (aparcaments == 1) texteA = "buit";
    output.push('<li><a href="?id=' + item.Identificador + '#estacio" rel="external">'
                                + iden
                                + '<br/><br/><p>'
                                + '<div class="ui-grid-b">'
                                + '<div class="ui-block-a" style="width:33%">'
                                + '<font color="' + colorB + '">' + imgB + ' ' + bicis + ' ' + texteB + '</font>'
                                + '</div>'
                                + '<div class="ui-block-b" style="width:33%">'
                                + '<font color="' + colorA + '">' + imgA + ' ' + aparcaments + ' ' + texteA + '</font>'
                                + '</div>'
                                + '<div class="ui-block-c" style="width:33%">'
                                + '<img src="images/mountain.png" style="vertical-align:middle"> ' + item.Alcada + ' metres'
                                + '</div>'
                                + '</div>'
                                + '</p>'
                                + '</a></li>');
    $('#infoEstacio').children("ul").empty().append(output.join("")).listview("refresh");

}

function mostrarDadesEstacio(identificador) {
    var output = [];
    var texteActualitzacio = "";
    var texteHora = "";
    var texteMinuts = "";

    // Mirem si el dia d'actualització és posterior al dia d'avui i creem texte a mostrar
    var darreraActualitzacio = JSON.parse(localStorage.dadesEstacions).DataActualitzacio * 1000;
    var dataAra = new Date($.now());
    var dataActualitzacio = new Date(darreraActualitzacio);
    texteActualitzacio = "avui";
    if (dataActualitzacio.getDate() < dataAra.getDate()) {
        texteActualitzacio = "ahir";
    }
    if (dataActualitzacio.getHours() < 10) {
        texteHora = "0" + dataActualitzacio.getHours();
    } else {
        texteHora = dataActualitzacio.getHours();
    }
    if (dataActualitzacio.getMinutes() < 10) {
        texteMinuts = "0" + dataActualitzacio.getMinutes();
    } else {
        texteMinuts = dataActualitzacio.getMinutes();
    }
    texteActualitzacio += " a les " + texteHora + ":" + texteMinuts;

    preferida = esPreferida(identificador);

    // Obtenim estacio amb identificador i emplenem dades pàgina 'Estació'
    var estacio = obtenirEstacioLocal(identificador)[0];
    var adreca = estacio.Carrer;
    if (estacio.NumeroCarrer != null && estacio.NumeroCarrer != "") {
        adreca += ", " + estacio.NumeroCarrer;
    }
    var iden = estacio.Identificador + " - " + adreca;

    var imgB = "<img src='images/Bicycle_Plain_Red.png' style='vertical-align:middle'>";
    var imgA = "<img src='images/Parking_P_Plain_Red.png' style='vertical-align:middle'>";
    if (estacio.BicisLliures >= 5) {
        colorB = "green";
        imgB = "<img src='images/Bicycle_Plain_Green.png' style='vertical-align:middle'>";
    }
    else if (estacio.BicisLliures > 0) {
        colorB = "orange";
        imgB = "<img src='images/Bicycle_Plain_Orange.png' style='vertical-align:middle'>";
    }
    if (estacio.AparcamentsLliures >= 5) {
        colorA = "green";
        imgA = "<img src='images/Parking_P_Plain_Green.png' style='vertical-align:middle'>";
    }
    else if (estacio.AparcamentsLliures > 0) {
        colorA = "orange";
        imgA = "<img src='images/Parking_P_Plain_Orange.png' style='vertical-align:middle'>";
    }

    $("#nomEstacio").html(String(iden));
    $("#adreca").html("<img src='images/page_white_edit.png' style='vertical-align:middle'> " + String(adreca));
    $("#labBicis").html(imgB + " Bicicletes:")
    $("#numBicis").html(String(estacio.BicisLliures));
    $("#labEmplacaments").html(imgA + " Emplaçaments:")
    $("#numEmplacaments").html(String(estacio.AparcamentsLliures));
    $("#labAltitud").html("<img src='images/mountain.png' style='vertical-align:middle'> Altitud aprox.:");
    $("#altitud").html(String(estacio.Alcada) + " metres");
    $("#labDistancia").html("<img src='images/Bookmark.png' style='vertical-align:middle'> Distància:");
    $("#distancia").html(String(Math.round(estacio.Distancia)) + " metres");
    $("#actualizacio").html("Darrera actualitzaci&oacute; d&#39;informaci&oacute; de les estacions: " + String(texteActualitzacio));
    if (preferida) {
        $("#checkboxPreferides").prop("checked", true).checkboxradio("refresh");
    }
    else $("#checkboxPreferides").prop("checked", false).checkboxradio("refresh");

    $.each(estacio.EstacionsProperes, function (i, item) {
        var estacioP = obtenirEstacioLocal(item)[0];
        var adreca = estacioP.Carrer;
        if (estacioP.NumeroCarrer != null && estacioP.NumeroCarrer != "") {
            adreca += ", " + estacioP.NumeroCarrer;
        }
        var iden = estacioP.Identificador + " - " + adreca;

        output.push('<li><a href="?id=' + estacioP.Identificador + '#estacio" rel="external">'
                        + iden
                        + '</a></li>');
    });
    $('#llistaEstacionsProperes').children("ul").empty().append(output.join("")).listview("refresh");

}

function tractarPreferides(identificador, afegir) {
    var preferides;
    if (localStorage["estacionsPreferides"] == undefined
        || localStorage["estacionsPreferides"].length == 0) {
        preferides = [];
    }
    else {
        preferides = JSON.parse(localStorage["estacionsPreferides"]);
    }
    var posicio = $.inArray(identificador, preferides);
    if (afegir) {
        if (posicio == -1) {
            preferides.push(identificador);
            localStorage["estacionsPreferides"] = JSON.stringify(preferides);
        }
    } else {
        if (posicio != -1) {
            preferides = $.grep(preferides, function (valor, j) {
                return valor != identificador;
            });
            if (preferides.length == 0) localStorage.removeItem("estacionsPreferides");
            else localStorage["estacionsPreferides"] = JSON.stringify(preferides);
        }

    }
}

function loading(MostrarOAmagar) {
    setTimeout(function () {
        $.mobile.loading(MostrarOAmagar);
    }, 1);
}

function errorGeo() {
    Geo.lat = "x";
    Geo.lng = "x";
    obtenirEstacions(Geo.lat, Geo.lng);
}

function obtenirEstacionsLocal() {
    var dadesEstacions = JSON.parse(localStorage.dadesEstacions);
    return dadesEstacions.LlistaEstacions;
}

function obtenirEstacioLocal(identificador) {
    var estacions = obtenirEstacionsLocal();
    estacions = $.grep(estacions, function (valor, j) {
        return valor.Identificador == identificador;
    });
    return estacions;
}

function getParameterByName(name) {
    var match = RegExp('[?&]' + name + '=([^&]*)').exec(window.location.search);
    return match && decodeURIComponent(match[1].replace(/\+/g, ' '));
}

function getRealContentHeight() {
    var header = $.mobile.activePage.find("div[data-role='header']:visible");
    var footer = $.mobile.activePage.find("div[data-role='footer']:visible");
    var content = $.mobile.activePage.find("div[data-role='content']:visible:visible");
    var viewport_height = $(window).height();
    var content_height = viewport_height - header.outerHeight() - footer.outerHeight();
    if ((content.outerHeight() - header.outerHeight() - footer.outerHeight()) <= viewport_height) {
        content_height -= (content.outerHeight() - content.height());
    }
    return content_height;
}

function getEspaiEntreOpcions(numOpcions) {
    var content_height = $('#contentIndex').outerHeight() - (130 * 2);
    var opcio = $('.opcio').outerHeight();
    content_height -= opcio * numOpcions;
    return content_height / (numOpcions - 1);
}

function esPreferida(identificador) {
    var result = false;

    // Mirem si és una de les estacions preferides
    if (localStorage["estacionsPreferides"] != undefined
        && localStorage["estacionsPreferides"].length > 0) {
        var preferides = localStorage["estacionsPreferides"];
        var posicio = $.inArray(identificador, JSON.parse(preferides));
        var preferida = false;
        if (posicio != -1) result = true;
    }

    return result;
}
